   1                     ; C Compiler for STM8 (COSMIC Software)
   2                     ; Generator V4.2.4 - 19 Dec 2007
  32                     ; 63 void EXTI_DeInit(void)
  32                     ; 64 {
  34                     	switch	.text
  35  0000               _EXTI_DeInit:
  39                     ; 65   EXTI->CR1 = EXTI_CR1_RESET_VALUE;
  41  0000 725f50a0      	clr	20640
  42                     ; 66   EXTI->CR2 = EXTI_CR2_RESET_VALUE;
  44  0004 725f50a1      	clr	20641
  45                     ; 67 }
  48  0008 81            	ret
 173                     ; 86 void EXTI_SetExtIntSensitivity(EXTI_Port_TypeDef Port, EXTI_Sensitivity_TypeDef SensitivityValue)
 173                     ; 87 {
 174                     	switch	.text
 175  0009               _EXTI_SetExtIntSensitivity:
 177  0009 89            	pushw	x
 178       00000000      OFST:	set	0
 181                     ; 90   assert_param(IS_EXTI_PORT_OK(Port));
 183                     ; 91   assert_param(IS_EXTI_SENSITIVITY_OK(SensitivityValue));
 185                     ; 94   switch (Port)
 187  000a 9e            	ld	a,xh
 189                     ; 116     default:
 189                     ; 117       break;
 190  000b 4d            	tnz	a
 191  000c 270e          	jreq	L12
 192  000e 4a            	dec	a
 193  000f 271d          	jreq	L32
 194  0011 4a            	dec	a
 195  0012 272e          	jreq	L52
 196  0014 4a            	dec	a
 197  0015 2742          	jreq	L72
 198  0017 4a            	dec	a
 199  0018 2756          	jreq	L13
 200  001a 2064          	jra	L311
 201  001c               L12:
 202                     ; 96     case EXTI_PORT_GPIOA:
 202                     ; 97       EXTI->CR1 &= (u8)(~EXTI_CR1_PAIS);
 204  001c c650a0        	ld	a,20640
 205  001f a4fc          	and	a,#252
 206  0021 c750a0        	ld	20640,a
 207                     ; 98       EXTI->CR1 |= (u8)(SensitivityValue);
 209  0024 c650a0        	ld	a,20640
 210  0027 1a02          	or	a,(OFST+2,sp)
 211  0029 c750a0        	ld	20640,a
 212                     ; 99       break;
 214  002c 2052          	jra	L311
 215  002e               L32:
 216                     ; 100     case EXTI_PORT_GPIOB:
 216                     ; 101       EXTI->CR1 &= (u8)(~EXTI_CR1_PBIS);
 218  002e c650a0        	ld	a,20640
 219  0031 a4f3          	and	a,#243
 220  0033 c750a0        	ld	20640,a
 221                     ; 102       EXTI->CR1 |= (u8)((u8)(SensitivityValue) << 2);
 223  0036 7b02          	ld	a,(OFST+2,sp)
 224  0038 48            	sll	a
 225  0039 48            	sll	a
 226  003a ca50a0        	or	a,20640
 227  003d c750a0        	ld	20640,a
 228                     ; 103       break;
 230  0040 203e          	jra	L311
 231  0042               L52:
 232                     ; 104     case EXTI_PORT_GPIOC:
 232                     ; 105       EXTI->CR1 &= (u8)(~EXTI_CR1_PCIS);
 234  0042 c650a0        	ld	a,20640
 235  0045 a4cf          	and	a,#207
 236  0047 c750a0        	ld	20640,a
 237                     ; 106       EXTI->CR1 |= (u8)((u8)(SensitivityValue) << 4);
 239  004a 7b02          	ld	a,(OFST+2,sp)
 240  004c 97            	ld	xl,a
 241  004d a610          	ld	a,#16
 242  004f 42            	mul	x,a
 243  0050 9f            	ld	a,xl
 244  0051 ca50a0        	or	a,20640
 245  0054 c750a0        	ld	20640,a
 246                     ; 107       break;
 248  0057 2027          	jra	L311
 249  0059               L72:
 250                     ; 108     case EXTI_PORT_GPIOD:
 250                     ; 109       EXTI->CR1 &= (u8)(~EXTI_CR1_PDIS);
 252  0059 c650a0        	ld	a,20640
 253  005c a43f          	and	a,#63
 254  005e c750a0        	ld	20640,a
 255                     ; 110       EXTI->CR1 |= (u8)((u8)(SensitivityValue) << 6);
 257  0061 7b02          	ld	a,(OFST+2,sp)
 258  0063 97            	ld	xl,a
 259  0064 a640          	ld	a,#64
 260  0066 42            	mul	x,a
 261  0067 9f            	ld	a,xl
 262  0068 ca50a0        	or	a,20640
 263  006b c750a0        	ld	20640,a
 264                     ; 111       break;
 266  006e 2010          	jra	L311
 267  0070               L13:
 268                     ; 112     case EXTI_PORT_GPIOE:
 268                     ; 113       EXTI->CR2 &= (u8)(~EXTI_CR2_PEIS);
 270  0070 c650a1        	ld	a,20641
 271  0073 a4fc          	and	a,#252
 272  0075 c750a1        	ld	20641,a
 273                     ; 114       EXTI->CR2 |= (u8)(SensitivityValue);
 275  0078 c650a1        	ld	a,20641
 276  007b 1a02          	or	a,(OFST+2,sp)
 277  007d c750a1        	ld	20641,a
 278                     ; 115       break;
 280  0080               L33:
 281                     ; 116     default:
 281                     ; 117       break;
 283  0080               L311:
 284                     ; 119 }
 287  0080 85            	popw	x
 288  0081 81            	ret
 346                     ; 134 void EXTI_SetTLISensitivity(EXTI_TLISensitivity_TypeDef SensitivityValue)
 346                     ; 135 {
 347                     	switch	.text
 348  0082               _EXTI_SetTLISensitivity:
 352                     ; 138   assert_param(IS_EXTI_TLISENSITIVITY_OK(SensitivityValue));
 354                     ; 141   EXTI->CR2 &= (u8)(~EXTI_CR2_TLIS);
 356  0082 721550a1      	bres	20641,#2
 357                     ; 142   EXTI->CR2 |= (u8)(SensitivityValue);
 359  0086 ca50a1        	or	a,20641
 360  0089 c750a1        	ld	20641,a
 361                     ; 144 }
 364  008c 81            	ret
 408                     ; 161 EXTI_Sensitivity_TypeDef EXTI_GetExtIntSensitivity(EXTI_Port_TypeDef Port)
 408                     ; 162 {
 409                     	switch	.text
 410  008d               _EXTI_GetExtIntSensitivity:
 412  008d 88            	push	a
 413       00000001      OFST:	set	1
 416                     ; 164   u8 value = 0;
 418  008e 0f01          	clr	(OFST+0,sp)
 419                     ; 167   assert_param(IS_EXTI_PORT_OK(Port));
 421                     ; 169   switch (Port)
 424                     ; 186     default:
 424                     ; 187       break;
 425  0090 4d            	tnz	a
 426  0091 270e          	jreq	L341
 427  0093 4a            	dec	a
 428  0094 2714          	jreq	L541
 429  0096 4a            	dec	a
 430  0097 271c          	jreq	L741
 431  0099 4a            	dec	a
 432  009a 2725          	jreq	L151
 433  009c 4a            	dec	a
 434  009d 2730          	jreq	L351
 435  009f 2035          	jra	L102
 436  00a1               L341:
 437                     ; 171     case EXTI_PORT_GPIOA:
 437                     ; 172       value = (u8)(EXTI->CR1 & EXTI_CR1_PAIS);
 439  00a1 c650a0        	ld	a,20640
 440  00a4 a403          	and	a,#3
 441  00a6 6b01          	ld	(OFST+0,sp),a
 442                     ; 173       break;
 444  00a8 202c          	jra	L102
 445  00aa               L541:
 446                     ; 174     case EXTI_PORT_GPIOB:
 446                     ; 175       value = (u8)((EXTI->CR1 & EXTI_CR1_PBIS) >> 2);
 448  00aa c650a0        	ld	a,20640
 449  00ad a40c          	and	a,#12
 450  00af 44            	srl	a
 451  00b0 44            	srl	a
 452  00b1 6b01          	ld	(OFST+0,sp),a
 453                     ; 176       break;
 455  00b3 2021          	jra	L102
 456  00b5               L741:
 457                     ; 177     case EXTI_PORT_GPIOC:
 457                     ; 178       value = (u8)((EXTI->CR1 & EXTI_CR1_PCIS) >> 4);
 459  00b5 c650a0        	ld	a,20640
 460  00b8 a430          	and	a,#48
 461  00ba 4e            	swap	a
 462  00bb a40f          	and	a,#15
 463  00bd 6b01          	ld	(OFST+0,sp),a
 464                     ; 179       break;
 466  00bf 2015          	jra	L102
 467  00c1               L151:
 468                     ; 180     case EXTI_PORT_GPIOD:
 468                     ; 181       value = (u8)((EXTI->CR1 & EXTI_CR1_PDIS) >> 6);
 470  00c1 c650a0        	ld	a,20640
 471  00c4 a4c0          	and	a,#192
 472  00c6 4e            	swap	a
 473  00c7 44            	srl	a
 474  00c8 44            	srl	a
 475  00c9 a403          	and	a,#3
 476  00cb 6b01          	ld	(OFST+0,sp),a
 477                     ; 182       break;
 479  00cd 2007          	jra	L102
 480  00cf               L351:
 481                     ; 183     case EXTI_PORT_GPIOE:
 481                     ; 184       value = (u8)(EXTI->CR2 & EXTI_CR2_PEIS);
 483  00cf c650a1        	ld	a,20641
 484  00d2 a403          	and	a,#3
 485  00d4 6b01          	ld	(OFST+0,sp),a
 486                     ; 185       break;
 488  00d6               L551:
 489                     ; 186     default:
 489                     ; 187       break;
 491  00d6               L102:
 492                     ; 190   return((EXTI_Sensitivity_TypeDef)value);
 494  00d6 7b01          	ld	a,(OFST+0,sp)
 497  00d8 5b01          	addw	sp,#1
 498  00da 81            	ret
 532                     ; 210 EXTI_TLISensitivity_TypeDef EXTI_GetTLISensitivity(void)
 532                     ; 211 {
 533                     	switch	.text
 534  00db               _EXTI_GetTLISensitivity:
 536  00db 88            	push	a
 537       00000001      OFST:	set	1
 540                     ; 216   value = (u8)(EXTI->CR2 & EXTI_CR2_TLIS);
 542  00dc c650a1        	ld	a,20641
 543  00df a404          	and	a,#4
 544  00e1 6b01          	ld	(OFST+0,sp),a
 545                     ; 218   return((EXTI_TLISensitivity_TypeDef)value);
 547  00e3 7b01          	ld	a,(OFST+0,sp)
 550  00e5 5b01          	addw	sp,#1
 551  00e7 81            	ret
 564                     	xdef	_EXTI_GetTLISensitivity
 565                     	xdef	_EXTI_GetExtIntSensitivity
 566                     	xdef	_EXTI_SetTLISensitivity
 567                     	xdef	_EXTI_SetExtIntSensitivity
 568                     	xdef	_EXTI_DeInit
 587                     	end
